<?php

/**
 * @Project FEEDNEWS ON NUKEVIET 4.x
 * @Author KENNYNGUYEN (nguyentiendat713@gmail.com)
 * @Copyright (C) 2014 VINADES.,JSC. All rights reserved
 * @License GNU/GPL version 2 or any later version
 * @Createdate 08/25/2015 10:27
 */
if (! defined('NV_IS_FILE_ADMIN'))
    die('Stop!!!');

$page_title = $lang_module['setting'];

$savesetting = $nv_Request->get_int('savesetting', 'post', 0);
if (! empty($savesetting)) {
    $array_config = array();
    $array_config['post_type'] = $nv_Request->get_title('post_type', 'post', 'direct', 1);
    $array_config['thumb_position'] = $nv_Request->get_int('thumb_position', 'post', 2);
    $array_config['st_links'] = $nv_Request->get_int('st_links', 'post', 10);
    $array_config['hometext'] = $nv_Request->get_int('hometext', 'post', 100);
    $array_config['prune_records'] = $nv_Request->get_int('prune_records', 'post', 10);
    $array_config['cron_user'] = $nv_Request->get_int('cron_user', 'post', 1);
    
    $sth = $db->prepare("UPDATE " . NV_CONFIG_GLOBALTABLE . " SET config_value = :config_value WHERE lang = '" . NV_LANG_DATA . "' AND module = :module_name AND config_name = :config_name");
    $sth->bindParam(':module_name', $module_name, PDO::PARAM_STR);
    foreach ($array_config as $config_name => $config_value) {
        $sth->bindParam(':config_name', $config_name, PDO::PARAM_STR);
        $sth->bindParam(':config_value', $config_value, PDO::PARAM_STR);
        $sth->execute();
    }
    
    $nv_Cache->delMod('settings');
    $nv_Cache->delMod($module_name);
    Header('Location: ' . NV_BASE_ADMINURL . 'index.php?' . NV_LANG_VARIABLE . '=' . NV_LANG_DATA . '&' . NV_NAME_VARIABLE . '=' . $module_name . '&' . NV_OP_VARIABLE . '=' . $op . '&rand=' . nv_genpass());
    die();
}

$xtpl = new XTemplate("setting.tpl", NV_ROOTDIR . "/themes/" . $global_config['module_theme'] . "/modules/" . $module_file);
$xtpl->assign('LANG', $lang_module);
$xtpl->assign('NV_BASE_ADMINURL', NV_BASE_ADMINURL);
$xtpl->assign('NV_NAME_VARIABLE', NV_NAME_VARIABLE);
$xtpl->assign('NV_OP_VARIABLE', NV_OP_VARIABLE);
$xtpl->assign('MODULE_NAME', $module_name);
$xtpl->assign('OP', $op);

$xtpl->assign('PRUNE_RECORDS', $module_config[$module_name]['prune_records']);
$xtpl->assign('HOMETEXT', $module_config[$module_name]['hometext']);

$array_post_type = array(
    1 => $lang_module['post_type_1'],
    2 => $lang_module['post_type_2']
);
foreach ($array_post_type as $key => $val) {
    $xtpl->assign('POST_TYPE', array(
        'key' => $key,
        'title' => $val,
        'selected' => $key == $module_config[$module_name]['post_type'] ? ' selected="selected"' : ''
    ));
    $xtpl->parse('main.post_type');
}

$array_imgposition = array(
    0 => $lang_module['imgposition_0'],
    1 => $lang_module['imgposition_1'],
    2 => $lang_module['imgposition_2']
);

// Vi tri anh minh hoa
while (list ($id_imgposition, $title_imgposition) = each($array_imgposition)) {
    $sl = ($id_imgposition == $module_config[$module_name]['thumb_position']) ? ' selected="selected"' : '';
    $xtpl->assign('id_imgposition', $id_imgposition);
    $xtpl->assign('title_imgposition', $title_imgposition);
    $xtpl->assign('posl', $sl);
    $xtpl->parse('main.looppos');
}

// Bai viet chi hien thi link
for ($i = 0; $i <= 30; ++ $i) {
    $xtpl->assign('ST_LINKS', array(
        'key' => $i,
        'title' => $i,
        'selected' => $i == $module_config[$module_name]['st_links'] ? ' selected="selected"' : ''
    ));
    $xtpl->parse('main.st_links');
}
// User assign lay tin tu dong
$db_slave->sqlreset()
    ->select('userid, username')
    ->from(NV_USERS_GLOBALTABLE)
    ->where('active=1');
$array_userid = array();
$result = $db_slave->query($db_slave->sql());
$array_users = $result->fetchAll();
foreach ($array_users as $user_i) {
    if ($user_i['userid'] == $module_config[$module_name]['cron_user']) {
        $user_i['selected'] = 'selected="selected"';
    } else {
        $user_i['selected'] = '';
    }
    $xtpl->assign('USER', $user_i);
    $xtpl->parse('main.cron_user');
}
$xtpl->assign('USER_ID', $admin_info['userid']);

$xtpl->parse('main');
$contents = $xtpl->text('main');
include (NV_ROOTDIR . "/includes/header.php");
echo nv_admin_theme($contents);
include (NV_ROOTDIR . "/includes/footer.php");
